# Introduction

We use decision template is based on
[Using patterns to capture architectural decisions](http://www.cs.rug.nl/~paris/papers/IEEESW07.pdf)
and [arc42 decisions](http://docs.arc42.org/section-9/)

To add a new decision copy template.md and add a link in the appropriate
section here.

## Implemented

- [Holes](holes.md)
- [Unit Testing](unit_testing.md)
- [Capabilities](capabilities.md)
- [Library Split](library_split.md)
- [Bootstrap](bootstrap.md)
- [Empty Files](empty_files.md)
- [CMake Plugins](cmake_plugins.md)
- [Logging](logging.md)
- [Internal Cache](internal_cache.md)
- [Elektra Web Structure](elektra_web.md)
- [Elektra Web Recursive Structure](elektra_web_recursive.md)
- [Cryptographic Key Handling](cryptograhic_key_handling.md)

## Decided

- [Relative Storages](relative.md)
- [API Documentation](api_documentation.md)
- [Definition of Bool](bool.md)
- [Plugin Variants](plugin_variants.md)

## In Discussion

- [CMake spec](cmake_spec.md)
- [Global Plugins](global_plugins.md)
- [Script Testing](script_testing.md)
- [Array](array.md)
- [Vendor Spec](vendor_spec.md)
- [Deferred Plugin Calls](deferred_plugin_calls.md)

## Drafts

- [Specification](specification.md)
- [Null Pointer Checks](null_pointer_checks.md)
- [Publish Subscribe](pubsub.md)
- [Global Validation](global_validation.md)
- [Default Values](default_values.md)
- [High Level API](high_level_api.md)
